#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_game_level_config.h"
#include "FileEncrypt.h"
std::auto_ptr<M_game_level_config> M_game_level_config::msSingleton(nullptr);

int M_game_level_config::GetCount()
{
	return (int)mMapData.size();
}

const M_game_level_configData* M_game_level_config::GetData(int64_t ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int64_t, M_game_level_configData>& M_game_level_config::GetMapData()
{
	return mMapData;
}

void M_game_level_config::Reload()
{
	mMapData.clear();
	Load();
}

void M_game_level_config::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_game_level_configData data;
		{
			int64_t temp = 0;
			const char* str = element->Attribute("ID");
			tinyxml2::XMLUtil::ToInt64(str, &temp);
			data.mID = temp;
		}
		data.mleve = element->IntAttribute("leve");
		data.mup_exp = element->IntAttribute("up_exp");
		data.mmonster_num = element->IntAttribute("monster_num");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_game_level_config::Load()
{
	Load("../Config/M_game_level_config.xml");
}

M_game_level_config* M_game_level_config::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_game_level_config());
	}
	return msSingleton.get();
}
